#!/usr/bin/env bash
declare -a num # make number name array
num[1]=one
num[2]=two
num[3]=three
num[4]=four
num[5]=five
num[6]=six
num[7]=seven
num[8]=eight
num[9]=nine
declare -a val # make array to hold values
cat $1 | while read l; do # read standard input
	((i++)) # increment index

	li="$l"
	for ni in {1..9}; do # ascend through worded digits
		li=`echo $li | sed "s/${num[$ni]}/$ni/g"`
	done

	ld="$l"
	for nd in {9..1}; do # ... and descend
		ld=`echo $ld | sed "s/${num[$nd]}/$nd/g"`
	done

	lifd=`echo $li | grep -E -o '^[a-z]*?[0-9]'` # select distance to first match, ascending
	ldfd=`echo $ld | grep -E -o '^[a-z]*?[0-9]'` # then descending

	if [[ ${#ldfd} -lt ${#lifd} ]]; then # compare first match's distance
		bf=$ld
	else
		bf=$li
	fi

	ldld=`echo $ld | grep -E -o '[0-9][a-z]*?$'` # select distance to last match, ascending
	lild=`echo $li | grep -E -o '[0-9][a-z]*?$'` # then descending

	if [[ ${#ldld} -lt ${#lild} ]]; then # compare last match's distance
		bl=$ld
	else
		bl=$li
	fi

	first=`echo $bf | grep -E -o '^[a-z]*?[0-9]' | grep -o [0-9]`
	last=`echo $bl | grep -E -o '[0-9][a-z]*?$' | grep -o [0-9]` # extract the first and last number from the line
	val[$i]=`echo "($first*10)+$last" | bc` # assign combined number to the array at current index
	echo -n "total: "
	echo ${val[@]} | sed 's/ /+/g' | bc # combine all array elements into total
done | tail -1
