#!/bin/bash
sampleline="$(head -1 $1)"
linelen=${#sampleline}
declare -a nums
while read num; do
	nums+=( $num ) # append lines from below to array
done < <( # using process substitution to sidestep above array's scope funkiness
	cat $1 | tr '\n' ' ' | grep -Eobn '[0-9]{1,3}' # find number locations; this gets us <line>:<byte>:<match space>
);

for (( i = 0; i < ${#nums[@]}; i++ )); do
	rawnum="${nums[$i]}"; # grab current array element contents
	num="${rawnum##*\:}"; # remove all prefixing fields
	numline="${rawnum%%\:*}"; # remove all suffixing fields
	numbyte="${rawnum#*\:}"; # remove one prefixing field
	numbyte="${numbyte%%\:*}"; # .. then remove one suffixing field to get middle
	numlen="${#num}"; # number length
	# measure out byte window (annoyingly, cut starts its index at 1 instead of 0)
	before_above_offset=$(($numbyte-$linelen-1))
	before_above_offset=$(($before_above_offset>=1?$before_above_offset:1)) # check if variable is below 1
	after_above_offset=$(($numbyte-$linelen+$numlen))
	after_above_offset=$(($after_above_offset>=1?$after_above_offset:1))
	before_crrnt_offset=$(($numbyte))
	before_crrnt_offset=$(($before_crrnt_offset>=1?$before_crrnt_offset:1))
	after_crrnt_offset=$(($numbyte+$numlen+1))
	before_below_offset=$(($numbyte+$linelen+1))
	after_below_offset=$(($numbyte+$linelen+$numlen+2))
	# actually cut out that window
	above=$(cat $1 | cut -zb ${before_above_offset}-${after_above_offset} | tr -d '\0')
	crrnt=$(cat $1 | cut -zb ${before_crrnt_offset}-${after_crrnt_offset} | tr -d '\0')
	below=$(cat $1 | cut -zb ${before_below_offset}-${after_below_offset} | tr -d '\0')
	close="$(echo $above $crrnt $below | tr -cd [:graph:] | grep -o '[^0-9,\.]')" # find symbols in window
	# add em up and print if its a part
	if [[ ${#close} -gt 0 ]]; then
		parts=$(($parts+$num))
		echo parts: $parts
	fi
done | tail -1
