#!/usr/bin/env bash
declare -a game
declare -a copy
while read card; do
	c="$(echo "${card%\:*}" | tr -cd [:digit:])" # grab the game number
	game[$c]=${game[$c]:-0} # set wins to zero if game isnt initialized
	(( copy[$c]++ )) # marks down original copy

	while read win; do
		if $(echo "${card#*\:}" | cut -d '|' -f 2 | grep -wq "$win"); then # check numbers for a winner
			(( game[$c]++ ))
		fi
	done < <( echo -n "${card#*\:}" | cut -d '|' -f 1 | tr ' ' '\n' | sed '/^$/d' ) # seperate winning numbers, delimting by newline

	for (( i=1 ; i<=game[$c] ; i++ )); do # mark down won copies
		o=$((c+i))
		copy[$o]=$((copy[$o]?copy[$o]:0)) # make sure future game has a value
		copy[$o]=$((copy[$c]+copy[$o])) # actually calculate number of copies
	done

done< <( cat $1 ) # file input

echo -n "part 1: "
for wins in ${game[@]}; do
	if [[ $wins -gt 0 ]]; then # only try with exponents that will be > 0
		echo $(( 2**($wins-1) )) # calculate score for each game
	fi
done | tr '\n' '+' | sed 's/+$/\n/' | bc # add them up

echo -n "part 2: "
echo ${copy[@]} | tr ' ' '+' | bc # and add up copies
